<template>
  <div class="use-new-color-config china-register-form">
    <video
      v-if="background.IsHidden"
      class="fixed right-0 z-0 min-w-full min-h-full max-w-none"
      autoplay
      muted
      loop
    >
      <source
        :src="
          getAssetImage(
            'assets/theme/light_flexible_1/desktop/images/login-register-bg.mp4'
          )
        "
        loading="lazy"
      />
    </video>
    <div v-else class="fixed right-0 min-w-full min-h-full z-1 max-w-none">
      <img class="w-screen h-screen" :src="background.ImagePath" loading="lazy" />
    </div>
    <main
      id="auth__main"
      class="flex items-center justify-center min-h-screen py-10"
    >
      <div class="flex items-center justify-center">
        <div
          class="z-10 flex flex-col items-center justify-center login__content"
        >
          <div v-if="!sponsorEnabled.IsHidden">
            <div
              class="flex justify-center items-center gap-5 mt-4 my-2 text-[14px]"
            >
              <div class="border-across-title">
                <span class="text-xs text-white">{{ $t("sponsors") }}</span>
              </div>
            </div>
            <div class="flex justify-between w-full px-4">
              <div
                v-for="sponsor in sponsors"
                :key="sponsor"
                class="flex flex-col items-center justify-center"
              >
                <img class="w-[58px]" :src="sponsor.ImagePath" loading="lazy" />
                <div class="text-center text-slate-300 text-[9px] justify-center">
                  {{ sponsor.Text }}
                </div>
              </div>
            </div>
          </div>
          <div class="w-[1200px] flex-none m-auto bg-background5 rounded-2xl overflow-hidden">
            <div class="h-[64px] bg-background5 flex items-center justify-between py-0 pl-[40px] pr-[16px]">
              <h1 class="text-left text-2xl font-semibold text-[var(--primary)] whitespace-nowrap">
                {{ $t("joinnow") }}
              </h1>
              <close-button />
            </div>
            <div class="w-full h-[2px] bg-border"></div>
            <el-col class="w-[400px] bg-background5 h-[654px] overflow-hidden">
              <el-form
                id="check-in-form"
                ref="formRef"
                class="w-full flex justify-center register-bg py-6 px-10"
                :model="formModel"
                :rules="formRules"
                status-icon
              >
                <div class=" flex flex-col gap-4">
                  <div class="register-form overflow-y-scroll overflow-x-hidden flex flex-col gap-4 h-[380px] pb-2">
                    <el-form-item class="input__container" prop="Username">
                      <el-input
                        v-model="formModel.Username"
                        class="text-[14px] required"
                        :disabled="isLoading"
                        :placeholder="$t('username')"
                      >
                        <template #prefix>
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/user-icon.png'
                              )
                            "
                            alt="user icon"
                            loading="lazy"
                          />
                        </template>
                      </el-input>
                    </el-form-item>
                    <el-form-item class="input__container required" prop="Password">
                      <el-input
                        id="passwd"
                        v-model="formModel.Password"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="password"
                        :placeholder="$t('password')"
                      >
                        <template #prefix>
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/lock-icon.png'
                              )
                            "
                            alt="lock icon"
                            loading="lazy"
                          />
                        </template>
                      </el-input>
                    </el-form-item>
                    <el-form-item
                      class="input__container required"
                      prop="ConfirmPassword"
                    >
                      <el-input
                        id="passwd"
                        v-model="formModel.ConfirmPassword"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="password"
                        :placeholder="$t('confirm_password')"
                      >
                        <template #prefix>
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/lock-icon.png'
                              )
                            "
                            alt="lock icon"
                            loading="lazy"
                          />
                        </template>
                      </el-input>
                    </el-form-item>
                    <el-form-item
                      class="input__container"
                      prop="Currency"
                      :class="{ required: rules.Currency.required }"
                    >
                      <el-select
                        v-model="formModel.Currency"
                        class="currency bg-transparent text-[14px]"
                        :placeholder="$t('select_currency')"
                        popper-class="bg-dropdown-customize"
                        style="width: 100%"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="dollar" />
                        </template>
                        <el-option
                          v-for="currency in currencies"
                          :key="currency"
                          :value="currency.Currency"
                        >
                          {{ currency.Currency }}</el-option
                        >
                      </el-select>
                    </el-form-item>
                    <template v-for="property in availableProperties" :key="property.PropertyName">
                    <theme-common-otp-field
                      v-if="property.PropertyName === 'Phone'"
                      v-model="formModel"
                      :label="property.PropertyNameForDisplay"
                      :phone-property="property.PropertyName"
                      :is-required="rules[property.PropertyName].required"
                      :loading="isGettingOtpCode"
                      :next-request-in-seconds="nextRequestOtpInSeconds"
                      @get-code="onGetVerificationCode"
                    >
                      <template #phone>
                        <el-form-item
                          :prop="property.PropertyName"
                          class="input__container"
                          :class="{ required: rules[property.PropertyName].required }"
                        >
                          <el-input
                            v-model="formModel[property.PropertyName]"
                            :disabled="isLoading"
                            class="bg-transparent text-[14px]"
                            type="text"
                            :placeholder="property.PropertyNameForDisplay"
                            :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')"
                          >
                            <template #prefix>
                              <font-awesome-icon icon="phone" />
                            </template>
                          </el-input>
                        </el-form-item>
                      </template>
                    </theme-common-otp-field>
                    <el-form-item
                      v-else
                      :prop="property.PropertyName"
                      class="input__container"
                      :class="{ required: rules[property.PropertyName].required }"
                    >
                      <el-select
                        v-if="property.PropertyName === 'Bank'"
                        v-model="formModel.Bank"
                        class="bg-transparent text-[14px] w-full"
                        :placeholder="$t('select_bank')"
                        :disabled="bankOptions.length <= 0"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="bank" />
                        </template>
                        <el-option
                          v-if="bankOptions.length <= 0"
                          label="--"
                          value="0"
                        />
                        <el-option
                          v-else
                          v-for="bank in bankOptions"
                          :key="bank.Id"
                          :label="bank.BankName"
                          :value="String(bank.Id)"
                        />
                      </el-select>
                      <div
                        v-else-if="property.PropertyName === 'Gender'"
                        class="el-input"
                      >
                        <span class="el-input__prefix">
                          <span class="el-input__prefix-inner">
                            <font-awesome-icon icon="venus-mars" />
                          </span>
                        </span>
                        <el-radio-group
                          v-model="formModel.Gender"
                          class="grid-cols-2 pl-[41px] py-[2.5px]"
                          >
                          <el-radio label="male">{{ $t("male") }}</el-radio>
                          <el-radio label="female">{{ $t("female") }}</el-radio>
                        </el-radio-group>
                      </div>
                      <el-input
                        v-else-if="property.PropertyName === 'Email'"
                        v-model="formModel[property.PropertyName]"
                        :class="{required : rules.Email.required}"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="text"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="at" />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'FirstName'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="text"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="file-invoice" />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'LastName'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="text"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="file-invoice" />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'FullName'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="text"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="user" loading="lazy" />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'Mobile'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="text"
                        :placeholder="property.PropertyNameForDisplay"
                        :formatter="(value: string) => value" 
                        :parser="(value: string) => value.replace(/\D+/g, '')"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="mobile" loading="lazy" />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'Line'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="isLoading"
                        class="bg-transparent text-[14px]"
                        type="text"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <img
                            :src="
                              getAssetImage(
                                'assets/theme/light_flexible_1/desktop/images/line-icon.png'
                              )
                            "
                            alt="line"
                            loading="lazy"
                          />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'BankAccountName'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="formModel.Bank === '0' || formModel.Bank === ''"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="money-check" loading="lazy" />
                        </template>
                      </el-input>
                      <el-date-picker
                        v-else-if="property.PropertyName === 'DateOfBirth'"
                        v-model="formModel[property.PropertyName]"
                        :placeholder="property.PropertyNameForDisplay"
                        type="date"
                        value-format="YYYY-MM-DD"
                      />
                      <el-input
                        v-else-if="property.PropertyName === 'BankAccountNumber'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="formModel.Bank === '0' || formModel.Bank === ''"
                        :placeholder="property.PropertyNameForDisplay"
                        :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="money-bill" loading="lazy" />
                        </template>
                      </el-input>
                      <el-input 
                      v-else-if="property.PropertyName === 'Mobile'" 
                      v-model="formModel[property.PropertyName]" 
                      :placeholder="$t('mobile')"
                      :formatter="(value: string) => value" 
                      :parser="(value: string) => value.replace(/\D+/g, '')"></el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'Referral'"
                        v-model="formModel[property.PropertyName]"
                        :disabled="referralQuery.length"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="users" loading="lazy" />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'PersonalSecurityCode'"
                        v-model="formModel[property.PropertyName]"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="user-shield" loading="lazy" />
                        </template>
                      </el-input>
                      <el-input
                        v-else-if="property.PropertyName === 'Nationality'"
                        v-model="formModel[property.PropertyName]"
                        :placeholder="property.PropertyNameForDisplay"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="flag" loading="lazy" />
                        </template>
                      </el-input>
                      <el-input
                        v-else
                        v-model="formModel[property.PropertyName]"
                        class="bg-transparent text-[14px]"
                        :placeholder="property.PropertyNameForDisplay"
                      />
                    </el-form-item>
                    </template>
                    <el-form-item v-if="cashAgentQuery.length" class="input__container">
                      <el-input
                        v-model="formModel.AgentName"
                        :disabled="cashAgentQuery.length"
                      >
                        <template #prefix>
                          <font-awesome-icon icon="users" loading="lazy" />
                        </template>
                      </el-input>
                    </el-form-item>
                    <el-form-item
                      v-if="!clientCaptcha.IsHidden"
                      prop="Captcha"
                      class="required"
                    >
                      <div class="captcha__container">
                        <div class="flex items-center w-full">
                          <template
                            v-if="
                              !captchaErrorMsg.length &&
                              formModel.Captcha.length == 5 &&
                              !isDialogVisible
                            "
                          >
                            <div class="h-[25px] w-[25px]">
                              <img
                                :src="
                                  getAssetImage(
                                    'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                                  )
                                "
                                alt=""
                                loading="lazy"
                              />
                            </div>
                            <div class="text-white truncate text-click-to-verify">
                              {{ $t("successful_verification") }}
                            </div>
                          </template>
                          <template v-else>
                            <div
                              class="flex items-center w-full"
                              @click="isDialogVisible = true"
                            >
                              <div class="h-[25px] w-[25px]">
                                <img
                                  :src="
                                    getAssetImage(
                                      'assets/theme/light_flexible_1/desktop/images/verify-icon.png'
                                    )
                                  "
                                  alt=""
                                  loading="lazy"
                                />
                              </div>
                              <div class="text-white truncate text-click-to-verify">
                                {{ $t("click_to_verify") }}
                              </div>
                            </div>
                          </template>
                        </div>
                      </div>
                    </el-form-item>
                  </div>
                  <el-divider class="bg-border" />
                  <div class="default__container text-[14px]">
                    <div class="text-center cursor-pointer text5" @click="isShowTerms = true">
                      When you click register, mean you agree with the
                      <span class="display-term-and-condition text-primary underline cursor-pointer">
                        Terms & Condition
                      </span>
                    </div>
                  </div>
                  <el-dialog
                    v-model="isShowTerms"
                    :align-center="true"
                    :lock-scroll="true"
                    width="656px"
                    custom-class="term-header"
                    :show-close="false"
                  >
                    <template #title>
                      <div
                        class="flex items-center justify-start pl-2 font-bold text-white header-title"
                      >
                        <p class="text-[16px]">{{ termConditionHeader.Text }}</p>
                      </div>
                    </template>
                    <div
                      class="p-6 space-y-6 text-[#6c7ba8] text-left text-[16px] content-body h-[96px] overflow-y-auto"
                      v-html="termConditionContent.Text"
                    ></div>
                    <template #footer>
                      <div
                        class="flex items-center px-2 pt-[0.6rem] space-x-2 rounded-b border-t border-gray-200 dark:border-gray-600"
                        @click="isShowTerms = false"
                      >
                        <span
                          class="text-blue-700 text-[16px] font-medium cursor-pointer"
                          >OK</span
                        >
                      </div>
                    </template>
                  </el-dialog>
                  <el-button
                    id="btn-submit-to-login"
                    :loading="isLoading"
                    class="input__container my-5 flex justify-center"
                    @click="onRegister(formRef)"
                    >{{ $t("joinnow") }}</el-button
                  >
                  <div class="flex justify-between text5 w-full text-[14px]">
                    <div class="w-full flex items-center justify-center">
                      <span class="text5">{{ $t("already_register") }}?</span>
                      <span class="pl-1 text-inherit text5">
                        <nuxt-link
                          class="text-primary underline cursor-pointer pr-1"
                          to="/login"
                          >{{ $t("capital_login") }}</nuxt-link
                        >|
                      </span>
                      <span class="text-primary underline cursor-pointer pl-1" @click="goHome">
                        {{ $t("skip_login")}}
                      </span>
                    </div>
                  </div>
                </div>
              </el-form>
            </el-col>
            <el-col class="relative register-info w-[800px] h-[654px] flex flex-col justify-center text-center ol-bg-light">
              <div class="text-center">
                <div class="w-[752px] h-[504px]">
                  <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
                </div>
                <div class="text-primary text-2xl font-black mb-1">
                  <span>{{ $t('welcome_to') }}</span>
                  <span v-if="!companyName.IsHidden" class="font-black text-[32px] fc-text4 ml-1">{{ companyName.Text }}</span>
                </div>
                <div class="fc-text4 text-base">{{ $t(loginRegister.Text) }}</div>
              </div>
            </el-col>
        </div>
        </div>
      </div>
    </main>
    <el-dialog
      v-model="isDialogVisible"
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      width="320px"
      @open="formModel.Captcha = ''"
      @close="formRef?.validateField('Captcha')"
    >
      <utils-client-captcha
        v-if="!clientCaptcha.IsHidden"
        v-model:captcha="formModel.Captcha"
        v-model:dialogVisible="isDialogVisible"
        :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, PropType } from "vue";
import { Search } from "@element-plus/icons-vue";
import useRegister from "@/composables/useRegister";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "~~/store";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  name: "Login",
  emits: ["toggleRegister", "toggleTerms"],
  setup(props, { emit }) {
    const router = useRouter();
    const {
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      isLoading,
      clientCaptcha,
      getCaptchaErrorMsg,
      captchaErrorMsg,
      availableProperties,
      referralQuery,
      bankOptions,
      cashAgentQuery,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    const { getAssetImage } = commonHelper;
    const isFocusUsername = ref(false);
    const isFocusPhone = ref(false);
    const isFocusEmail = ref(false);
    const toggleRegister = () => {
      emit("toggleRegister");
    };
    const toggleTerms = () => {
      emit("toggleTerms");
    };
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const companyName = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register_company_name"
      )
    );
    const sponsorEnabled = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_1"
        )
    );
    const sponsors = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          "index_blog_1_"
        )
    );
    const background = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "background_image"
        )
    );
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "logo"
        )
    );
    function addMinutes(numOfMinutes: number, date = new Date()) {
      date.setMinutes(date.getMinutes() + numOfMinutes);
      return date;
    }
    const termConditionContent = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "menu_content_2_1"
        )
    );
    const termConditionHeader = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "footer_menu_info_2"
        )
    );
    const goHome = () => {
      document.cookie = `skipLogin=true;expires=${addMinutes(10)};path=/`;
      router.replace("/");
    };
    const isShowTerms = ref(false);
    const isDialogVisible = ref(false);
    const loginRegister = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register"
      )
    );
    return {
      companyName,
      loginRegister,
      toggleRegister,
      toggleTerms,
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      isLoading,
      clientCaptcha,
      isFocusUsername,
      isFocusPhone,
      isFocusEmail,
      Search,
      sponsors,
      sponsorEnabled,
      logo,
      goHome,
      background,
      isShowTerms,
      getCaptchaErrorMsg,
      captchaErrorMsg,
      isDialogVisible,
      availableProperties,
      bankOptions,
      referralQuery,
      cashAgentQuery,
      rules,
      termConditionContent,
      termConditionHeader,
      getAssetImage,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    };
  },
});
</script>

<style lang="scss">
.register-info {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}
div.el-select-dropdown.bg-dropdown-customize {
  background: #fff !important;
}

div.el-select-dropdown.bg-dropdown-customize .el-select-dropdown__item {
  color: #6c7ba8;
}

div.el-select__popper.bg-dropdown-customize {
  top: 677px;
}
.china-register-form {
  .input__container {
    .el-input {
      box-shadow: none;
      border: solid 1px var(--border);
      background: var(--background5);
      .el-input__inner {
        color: var(--text5);
        background-color: transparent;
        &::placeholder {
          color: var(--text5);
          opacity: 0.5;
        }
      }
    }
  }
}
</style>
<style scoped>
:deep(.el-select .el-input.is-focus .el-input__inner) {
  box-shadow: none !important;
}

:deep(.el-select .el-input__inner:focus) {
  box-shadow: none !important;
}

.captcha__container {
  display: flex;
  border-radius: 20px;
  line-height: 44px;
  height: 40px;
  width: 100%;
  box-shadow: inset 0 1px 15px 0 #fff;
  background-color: rgba(255, 255, 255, 0.5);
  align-items: center;
  color: #fff !important;
  padding-left: 12px;
}

:deep(.el-button) {
  --el-button-bg-color: #3d72fa;
  --el-button-hover-bg-color: #3d72fa;
}

:deep(
    .el-button.is-disabled,
    .el-button.is-disabled:focus,
    .el-button.is-disabled:hover
  ) {
  --el-button-disabled-bg-color: #3d72fa;
}

:deep(.el-dialog__header) {
  background: linear-gradient(90deg, #62b3ff, #3d72fa) !important;
  padding-top: 14.5px !important;
  padding-bottom: 14.5px !important;
  border-top-left-radius: 5px;
  border-top-right-radius: 5px;
  margin-right: 0px;
}

:deep(.el-dialog__footer) {
  padding: 0;
  height: 41px;
}

:deep(.el-dialog) {
  --el-dialog-bg-color: var(--background2);
  border-bottom-left-radius: 5px !important;
  border-bottom-right-radius: 5px !important;
  border-radius: 10px;
  margin-top: 300px;
  height: fit-content;
}
.el-form-item {
  display: block;
}
.text-primary {
  color: var(--primary);
}
.register-inner {
  display: block;
}
.el-button.is-round {
  border-radius: 4px;
}
.register-form::-webkit-scrollbar {
    display: none;
}
.el-divider--horizontal {
  border: 0;
  margin: 0;
}
.text5 {
  color: var(--text5);
}
:deep(.el-input__suffix-inner) {
  gap: 8px;
}
:deep(.el-input.is-disabled .el-input__inner) {
  -webkit-text-fill-color: var(--text5);
  opacity: 0.5;
}
</style>
